From ba226d945dd784aa21c70584c464a11e890d2b90 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Tue, 29 Oct 2024 10:11:59 +0800
Subject: [PATCH] Add evtest build shell script

---
 openlibs/pppd/build.sh |  216 +++++++++++++++++++++++++++++++++++++-----------------
 1 files changed, 148 insertions(+), 68 deletions(-)

diff --git a/openlibs/pppd/build.sh b/openlibs/pppd/build.sh
index 18af25b..2b9cd52 100755
--- a/openlibs/pppd/build.sh
+++ b/openlibs/pppd/build.sh
@@ -1,45 +1,120 @@
 #!/bin/bash
 
-#+--------------------------------------------------------------------------------------------
-#|Description:  This shell script used download and compile pppd for ARM
-#|     Author:  GuoWenxue <guowenxue@gmail.com>
-#|  ChangeLog:
-#|           1, Initialize 1.0.0 on 2011.04.12
-#+--------------------------------------------------------------------------------------------
+# library name and version
+# Official: https://github.com/ppp-project/ppp/tags
+LIB_NAME=ppp-2.5.0
+PACK_SUFIX=tar.gz
 
-PREFIX_PATH=`pwd`/../install/bin
-
+# LingYun source code FTP server
 LYFTP_SRC=http://master.weike-iot.com:2211/src/
 
+# library download URL address
+LIB_URL=$LYFTP_SRC
+
+# Cross compiler for cross compile on Linux server
 CROSS_COMPILE=/opt/gcc-aarch32-10.3-2021.07/bin/arm-none-linux-gnueabihf-
 
-SYSROOT=`${CROSS_COMPILE}gcc -print-sysroot`
+# compile jobs
+JOBS=`cat /proc/cpuinfo |grep "processor"|wc -l`
 
-function msg_banner()
-{
-    echo ""
-    echo "+-----------------------------------------------------------------------"
-    echo "|  $1 "
-    echo "+-----------------------------------------------------------------------"
-    echo ""
+# this project absolute path
+PRJ_PATH=$(cd $(dirname "${BASH_SOURCE[0]}") && pwd)
+
+# top project absolute path
+TOP_PATH=$(realpath $PRJ_PATH/..)
+
+# binaries install path
+PREFIX_PATH=$TOP_PATH/install
+BIN_PATH=$PREFIX_PATH/bin
+LIB_PATH=$PREFIX_PATH/lib
+INC_PATH=$PREFIX_PATH/include
+
+# check installed or not file
+INST_FILE=$PREFIX_PATH/bin/pppd
+
+# shell script will exit once get command error
+set -e
+
+#+-------------------------+
+#| Shell script functions  |
+#+-------------------------+
+
+function pr_error() {
+    echo -e "\033[40;31m $1 \033[0m"
+}
+
+function pr_warn() {
+    echo -e "\033[40;33m $1 \033[0m"
+}
+
+function pr_info() {
+    echo -e "\033[40;32m $1 \033[0m"
 }
 
 function check_result()
 {
     if [ $? != 0 ] ; then
-       echo ""
-       echo "+-----------------------------------------------------------------------"
-       echo "|  $1 "
-       echo "+-----------------------------------------------------------------------"
-       echo ""
-       exit ;
+        pr_error "$1"
     fi
 }
-
-function export_cross()
+# decompress a packet to destination path
+function do_unpack()
 {
+    tarball=$1
+    dstpath=`pwd`
+
+    if [[ $# == 2 ]] ; then
+        dstpath=$2
+    fi
+
+    pr_info "decompress $tarball => $dstpath"
+
+    mkdir -p $dstpath
+    case $tarball in
+        *.tar.gz)
+            tar -xzf $tarball -C $dstpath
+            ;;
+
+        *.tar.bz2)
+            tar -xjf $tarball -C $dstpath
+            ;;
+
+        *.tar.xz)
+            tar -xJf $tarball -C $dstpath
+            ;;
+
+        *.tar.zst)
+            tar -I zstd -xf $tarball -C $dstpath
+            ;;
+
+        *.tar)
+            tar -xf $tarball -C $dstpath
+            ;;
+
+        *.zip)
+            unzip -qo $tarball -d $dstpath
+            ;;
+
+        *)
+            pr_error "decompress Unsupport packet: $tarball"
+            return 1;
+            ;;
+    esac
+}
+
+function do_export()
+{
+    BUILD_ARCH=$(uname -m)
+    if [[ $BUILD_ARCH =~ "arm" ]] ; then
+        pr_warn "local($BUILD_ARCH) compile $LIB_NAME"
+        return ;
+    fi
+
+    pr_warn "cross(${CROSS_COMPILE}) compile $LIB_NAME"
+
     # export cross toolchain
     export CC=${CROSS_COMPILE}gcc
+    export CXX=${CROSS_COMPILE}g++
     export AS=${CROSS_COMPILE}as
     export AR=${CROSS_COMPILE}ar
     export LD=${CROSS_COMPILE}ld
@@ -48,7 +123,7 @@
     export OBJDUMP=${CROSS_COMPILE}objdump
     export STRIP=${CROSS_COMPILE}strip
 
-    # export cross configure 
+    # export cross configure
     export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
 
     # Clear LDFLAGS and CFLAGS
@@ -56,58 +131,63 @@
     export CFLAGS=
 }
 
-function compile_pppd()
+function do_fetch()
 {
-    SRC_NAME=ppp-2.4.7
-    PACK_SUFIX=tar.gz
-
-    if [ -f ${PREFIX_PATH}/pppd ] ; then
-        msg_banner "$SRC_NAME already compile and installed"
-        return 0;
+    if [ -e ${INST_FILE} ] ; then
+        pr_warn "$LIB_NAME compile and installed alredy"
+        exit ;
     fi
 
-    msg_banner "Start cross compile $SRC_NAME "
-
-    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
-        #wget https://download.samba.org/pub/ppp/${SRC_NAME}.${PACK_SUFIX}
-        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
-        check_result "ERROR: download ${SRC_NAME} failure"
+    if [ -d $LIB_NAME ] ; then
+        pr_warn "$LIB_NAME fetch already"
+        return ;
     fi
 
-    rm -rf ${SRC_NAME}
-    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    if [ ! -f ${LIB_NAME}.${PACK_SUFIX} ] ; then
+        wget ${LIB_URL}/${LIB_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${LIB_NAME} failure"
+    fi
 
-    cd ${SRC_NAME}
-    patch -p1 < ../patch/${SRC_NAME}.patch
-
-    sed -i -e "s|.*CC = .*|CC=${CROSS_COMPILE}gcc|g" pppd/Makefile.linux
-    sed -i -e "s|^OPENSSL_INCLUDE_DIR=.*|OPENSSL_INCLUDE_DIR=${SYSROOT}/usr/include/openssl|g" pppd/Makefile.linux
-    sed -i -e "s|.*CC = .*|CC=${CROSS_COMPILE}gcc|g" chat/Makefile.linux
-
-    cd pppd 
-        make CC="${CROSS_COMPILE}gcc -static" -f Makefile.linux && ${CROSS_COMPILE}strip pppd 
-        check_result "ERROR: compile ${SRC_NAME} pppd failure"
-        cp pppd ../../
-    cd -
-
-    cd  chat
-        make CC="${CROSS_COMPILE}gcc -static" -f Makefile.linux && ${CROSS_COMPILE}strip chat
-        check_result "ERROR: compile ${SRC_NAME} chat failure"
-        cp chat ../..
-    cd -
-
-    check_result "ERROR: compile ${SRC_NAME} failure"
-
-    cd ..
-
-    cp pppd chat ${PREFIX_PATH} 
-
-    cd -
+    do_unpack ${LIB_NAME}.${PACK_SUFIX}
 }
 
+function do_build()
+{
+    cd $LIB_NAME
 
-export_cross
+    if [ ! -e configure ] ; then
+        ./autogen.sh
+    fi
 
-compile_pppd
+    do_export
 
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} \
+        --disable-plugins --disable-eaptls --disable-peap \
+        --with-openssl=${PREFIX_PATH}
+
+    check_result "ERROR: configure ${LIB_NAME} failure"
+
+    sed -i -e "/HAVE_CRYPT_H/d" pppd/config.h
+    make -j ${JOBS} CFLAGS="-I ${INC_PATH}" && make install
+    check_result "ERROR: compile ${LIB_NAME} failure"
+
+    pr_info "${LIB_NAME} installed to '${BIN_PATH}'"
+    install -m 755 pppd/pppd ${BIN_PATH}
+    install -m 755 chat/chat ${BIN_PATH}
+}
+
+function do_clean()
+{
+    rm -rf *${LIB_NAME}*
+}
+
+if [[ $# == 1 && $1 == -c ]] ;then
+    pr_warn "start clean ${LIB_NAME}"
+    do_clean
+    exit;
+fi
+
+do_fetch
+
+do_build
 

--
Gitblit v1.9.1